
//#ifdef __cplusplus
//extern "C" {
//#endif

#include "tricrypt/usb.h"
//#include "cdc_acm_core.h"
//#include "drv_usb_hw.h"
//#include "gd32vf103_usbd_hw.h"
//#include "tricrypt/error.h"
//#include "tricrypt/system.h"

//#ifdef __cplusplus
//}
//#endif






// Write to USB CDC, reading should be similar
void cdc_print(usb_dev *pudev, uint8_t *str, uint32_t data_len)
{
    packet_sent = 0;
    usbd_ep_send(pudev, CDC_ACM_DATA_IN_EP, str, data_len);
    bytes_sent += data_len;
}

usb_core_driver USB_OTG_dev = 
{
    .dev =
    {
        .desc =
        {
            .dev_desc       = (uint8_t *)&device_descriptor,
            .config_desc    = (uint8_t *)&configuration_descriptor,
            .strings        = usbd_strings,
        }
    }
};

void usb_init()
{
    eclic_global_interrupt_enable();

    eclic_priority_group_set(ECLIC_PRIGROUP_LEVEL2_PRIO2);

    usb_rcu_config();

    usb_timer_init();

    usb_intr_config();

    usbd_init(&USB_OTG_dev, USB_CORE_ENUM_FS, &usbd_cdc_cb);
}

void usb_wait()
{
    // check if USB device is enumerated successfully
    while(USBD_CONFIGURED != USB_OTG_dev.dev.cur_status);
}

void usb_receive()
{
    memset(buffer, 0, sizeof(buffer));

    bool running = true;

    while (running)
    {
        if (USBD_CONFIGURED == USB_OTG_dev.dev.cur_status)
        {
            if (1 == packet_receive && 1 == packet_sent)
            {
                packet_sent = 0;
                // receive data from the host when the last packet data have been sent to the host 
                //cdc_acm_data_receive(&USB_OTG_dev);
                usbd_ep_recev (&USB_OTG_dev, CDC_ACM_DATA_OUT_EP, rcvstr, 64);//receive
            }
            else    // if received
            {
                if (0 != receive_length)  // if receive isnt empty
                {
                    bytes_received += receive_length;
                    for (uint32_t i=0; i<receive_length; i++)  //max 64 for all received
                    {
                        if ((rcvstr[i] == '\r') || (rcvstr[i] == '\n'))  //end of rcvstr
                        {
                            buffer[idx+1] = 0;
                            if (strlen((char *)buffer) > 0)
                            {
                                tmpbuf[0] = 0;
                                if (str_ovf > 0)
                                {
                                    sprintf((char *)tmpbuf, "[ovf=%d]", str_ovf);
                                    int len = strlen((char *)tmpbuf);
                                    memcpy(buffer+100-len, tmpbuf, len);
                                }
                                LCD_Clear(BLACK);
                                LCD_ShowStr(0, 0, buffer, str_color, OPAQUE);
                                if(strcmp((char *)(buffer), "storage") == 0)
                                {
                                    //FATFS *fs;
                                    //DWORD fre_clust, fre_sect, tot_sect;
                                    //f_getfree("0:", &fre_clust, &fs);

                                    //tot_sect = (fs->n_fatent - 2) * fs->csize;
                                    //fre_sect = fre_clust * fs->csize;

                                    //LCD_ShowString(0,  0, (u8 *)("total" + tot_sect/2), RED);
                                    //LCD_ShowString(0,  32, (u8 *)("free" + fre_sect/2), RED);
                                }
                                else if(strcmp((char *)(buffer), "restart") == 0)
                                {
                                    running = false;
                                    i = receive_length;
                                    ///////////////////////////////////////////////////////////system_restart();

                                    while(TRUE)
                                    {
                                        ;
                                    }

                                    break;
                                    //continue;-->no restart bug
                                }

                                n_str++;
                            }
                            idx = 0;
                            str_ovf = 0;
                            memset(buffer, 0, sizeof(buffer));
                        }
                        if ((rcvstr[i] >= 32) && (rcvstr[i] < 128))  //if printable ascii char
                        {
                            // Copy received data to buffer
                            if (idx < 100)
                            {
                                buffer[idx] = rcvstr[i];
                                idx++;
                                // echo received characters
                                cdc_print(&USB_OTG_dev, &rcvstr[i], 1);
                            }
                            else
                            {
                                str_ovf++;
                                tmpbuf[0] = '>';
                                cdc_print(&USB_OTG_dev, tmpbuf, 1);
                            }
                        }
                        else
                        {
                            // test for control characters
                            if (rcvstr[i] == 18)
                            {
                                str_color = RED;    // Ctrl+R -> red color
                                cdc_print(&USB_OTG_dev, (uint8_t *)"red ok", 6);
                            }
                            else if (rcvstr[i] == 2)
                            {
                                str_color = BLUE;    // Ctrl+B -> blue color
                                //led_blue();
                            }
                            else if (rcvstr[i] == 7)
                            {
                                str_color = GREEN;    // Ctrl+G -> green color
                                //led_green();
                            }
                            else if (rcvstr[i] == 25)
                            {
                                str_color = YELLOW;    // Ctrl+Y -> yellow color
                               // led_yellow();
                            }
                            else if (rcvstr[i] == 3)
                            {
                                str_color = CYAN;    // Ctrl+C -> cyan color
                                //led_cyan();
                            }
                            else if (rcvstr[i] == 23)
                            {
                                str_color = WHITE;    // Ctrl+W -> white color
                               // led_white();
                            }
                            else if (rcvstr[i] == 4) LCD_Clear(BACK_COLOR);                            // Ctrl+D -> clear screen
                            else if (rcvstr[i] == 12)
                            {
                                LCD_Clear(BLACK);    // Ctrl+L -> show logo/edited
                            }
                            //else if (1 == 1){cdc_print(&USB_OTG_dev, rcvstr[i], 1);}//???
                            else if (rcvstr[i] == 19)
                            {
                                // Ctrl+S -> show status
                                LCD_Clear(BLACK);//edit
                                //LCD_ShowLogo();
                                sprintf((char *)tmpbuf, "Received: %d", bytes_received);
                                LCD_ShowStr(0, 32, tmpbuf, YELLOW, TRANSPARENT);
                                sprintf((char *)tmpbuf, "    Sent: %d", bytes_sent);
                                LCD_ShowStr(0, 48, tmpbuf, YELLOW, TRANSPARENT);
                                sprintf((char *)tmpbuf, " Strings: %d", n_str);
                                LCD_ShowStr(0, 64, tmpbuf, YELLOW, TRANSPARENT);
                            }
                        }

                    }

                    receive_length = 0;
                }
            }
        }
        else
        {
            LCD_Clear(BLACK);
            //LCD_ShowLogo(0);//edit
            //LCD_ShowStr(0, 48, (u8 *)("USB NOT ENUMERATED!"), RED, TRANSPARENT);
            // wait until USB device is enumerated again 
            while (USBD_CONFIGURED != USB_OTG_dev.dev.cur_status)
            {
            }
        }
    }
}
